SystemOrganization addCategory: #'Sitemap-Model'!
SystemOrganization addCategory: #'Sitemap-View'!

PRRawView subclass: #SitemapDownloadView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-View'!

SitemapDownloadView subclass: #SitemapDownloadGzipView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-View'!

!SitemapDownloadGzipView class methodsFor: 'testing' stamp: 'pmm 2/2/2006 12:16'!
isAbstract
	^false! !

!SitemapDownloadGzipView class methodsFor: 'testing' stamp: 'pmm 2/2/2006 12:16'!
label
	^'Download Gzip'! !

!SitemapDownloadGzipView methodsFor: 'accessing' stamp: 'pmm 2/2/2006 12:15'!
content
	^self generator xmlStringGZipCompressed! !

!SitemapDownloadGzipView methodsFor: 'accessing' stamp: 'pmm 2/2/2006 12:15'!
fileName
	^'sitemap.gz'! !

!SitemapDownloadGzipView methodsFor: 'accessing' stamp: 'pmm 2/2/2006 12:18'!
mimeType
	^'application/gzip'! !

SitemapDownloadView subclass: #SitemapDownloadPlainView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-View'!

!SitemapDownloadPlainView class methodsFor: 'testing' stamp: 'pmm 2/2/2006 11:21'!
isAbstract
	^false! !

!SitemapDownloadPlainView class methodsFor: 'accessing' stamp: 'pmm 2/2/2006 11:22'!
label
	^'Download'! !

!SitemapDownloadPlainView methodsFor: 'accessing' stamp: 'pmm 2/2/2006 12:10'!
content
	^self generator xmlString! !

!SitemapDownloadPlainView methodsFor: 'accessing' stamp: 'pmm 2/2/2006 11:55'!
fileName
	^'sitemap.xml'! !

!SitemapDownloadPlainView methodsFor: 'accessing' stamp: 'pmm 2/2/2006 11:55'!
mimeType
	^'text/xml'! !

!SitemapDownloadView class methodsFor: 'testing' stamp: 'pmm 2/2/2006 12:13'!
isValidIn: aContext
	^(super isValidIn: aContext)
		and: [ aContext structure isKindOf: Sitemap ]! !

!SitemapDownloadView methodsFor: 'accessing' stamp: 'pmm 2/2/2006 12:13'!
content
	self subclassResponsability ! !

!SitemapDownloadView methodsFor: 'accessing' stamp: 'pmm 2/2/2006 12:14'!
fileName
	self subclassResponsability ! !

!SitemapDownloadView methodsFor: 'accessing' stamp: 'pmm 2/2/2006 12:12'!
generator
	^SitemapGenerator forServerUrl: self sitemap serverUrl.! !

!SitemapDownloadView methodsFor: 'accessing' stamp: 'pmm 2/2/2006 12:14'!
mimeType
	self subclassResponsability ! !

!SitemapDownloadView methodsFor: 'rendering' stamp: 'pmm 2/2/2006 12:13'!
renderContentOn: aRequest
	aRequest 
		contentType: self mimeType;
		attachmentWithFileName: self fileName;
		nextPutAll: self content! !

!SitemapDownloadView methodsFor: 'accessing' stamp: 'pmm 2/2/2006 12:12'!
sitemap
	^self context structure! !

PRStructure subclass: #Sitemap
	instanceVariableNames: 'logoColor logoSize serverUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-Model'!

!Sitemap class methodsFor: 'accessing-description' stamp: 'pmm 2/2/2006 10:58'!
descriptionLogoColor
	^(MASingleOptionDescription selector: #logoColor label: 'Logo Color' priority: 500)
		options: self logoColors;
		default: self logoColors first;
		reference: MAStringDescription new;
		beRequired;
		yourself.! !

!Sitemap class methodsFor: 'accessing-description' stamp: 'pmm 2/2/2006 10:59'!
descriptionLogoSize
	^(MASingleOptionDescription selector: #logoSize label: 'Logo Size' priority: 600)
		options: self logoSizes;
		default: self logoSizes last;
		reference: MAStringDescription new;
		beRequired;
		yourself.! !

!Sitemap class methodsFor: 'accessing-resources' stamp: 'pmm 2/2/2006 10:53'!
icon
	"PRCompatibility compileFileNamed: 'google.png' into: Sitemap class selector: #icon"

	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 0 6 98 75 71 68 0 255 0 255 0 255 160 189 167 147 0 0 0 9 112 72 89 115 0 0 0 72 0 0 0 72 0 70 201 107 62 0 0 2 230 73 68 65 84 56 203 157 147 75 139 91 117 0 71 207 125 36 55 153 56 201 60 209 209 116 58 142 20 181 216 42 74 157 130 248 64 208 141 149 10 5 23 182 43 139 32 136 46 74 183 130 138 238 92 136 118 211 149 130 136 8 110 212 133 34 3 42 165 130 193 233 180 153 161 47 107 134 97 198 105 147 76 38 207 155 123 111 110 238 255 231 34 31 64 240 124 128 179 58 199 242 78 223 209 241 19 175 211 161 137 23 20 49 233 22 253 84 142 169 184 74 104 50 224 78 210 164 195 140 19 17 88 227 164 226 54 155 78 138 130 113 1 224 209 147 215 213 31 212 37 73 177 31 200 104 75 117 25 197 146 182 251 210 230 198 174 58 146 90 173 80 81 34 169 47 105 16 74 237 72 127 30 94 148 187 99 205 99 167 178 68 64 127 44 67 181 91 228 235 111 107 220 42 253 78 169 108 211 15 103 169 185 117 14 29 244 120 230 216 18 175 60 110 113 228 126 135 156 233 98 135 21 152 61 189 42 163 80 13 245 245 155 47 189 120 182 164 233 39 126 214 223 117 169 42 105 40 233 142 164 63 174 73 197 163 31 235 225 199 206 106 111 79 82 87 186 50 225 137 133 83 37 25 109 41 148 244 198 71 215 245 192 145 243 170 69 146 209 150 6 166 41 13 19 133 201 200 180 114 171 171 82 121 93 129 186 82 212 85 249 161 130 216 247 230 109 249 177 244 254 249 13 221 253 212 103 90 187 17 41 144 20 106 71 45 5 10 181 169 64 109 41 144 226 193 72 228 171 173 68 85 173 28 68 174 219 178 176 93 216 179 198 72 37 139 60 82 76 67 18 35 39 143 23 123 180 83 243 88 64 38 241 33 147 67 248 216 12 177 227 105 76 45 143 157 142 247 8 48 252 176 126 25 22 135 152 177 26 88 6 43 206 65 98 81 72 32 159 0 86 26 199 128 193 38 33 1 137 41 215 197 110 228 115 8 27 183 49 5 77 97 71 147 208 53 40 229 211 77 25 136 65 78 4 25 72 108 225 152 44 89 4 170 16 101 246 97 123 73 139 52 80 156 158 96 251 198 14 145 51 128 113 143 168 147 99 220 177 241 51 80 195 112 177 82 101 181 30 179 86 131 149 245 44 198 155 160 237 92 193 246 236 12 54 187 28 125 50 6 231 65 62 60 183 70 211 142 176 243 192 16 198 8 184 185 154 225 237 83 151 120 233 185 239 56 113 236 71 150 151 43 200 228 201 89 115 176 255 213 64 146 116 59 148 22 14 95 84 97 234 115 45 95 147 2 197 50 146 212 107 72 67 41 138 165 203 255 72 179 251 223 211 151 223 172 200 104 75 151 102 230 100 15 178 219 8 159 25 111 147 95 127 90 98 110 102 151 227 207 126 197 167 159 84 168 14 32 201 165 105 57 61 122 46 108 52 98 234 189 171 120 227 62 0 153 92 15 107 246 173 178 110 158 59 132 103 70 111 52 35 195 153 119 127 225 194 247 107 68 222 36 164 14 224 228 7 132 245 187 40 220 83 229 133 231 125 62 56 243 50 247 101 179 148 23 230 97 233 228 85 169 51 42 239 191 232 15 146 81 219 161 164 126 95 127 29 184 87 110 234 181 119 120 250 2 255 139 47 252 29 254 5 25 110 13 171 255 102 75 149 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray.! !

!Sitemap class methodsFor: 'testing' stamp: 'pmm 2/2/2006 10:40'!
isAbstract
	^false! !

!Sitemap class methodsFor: 'accessing' stamp: 'pmm 2/2/2006 10:41'!
label
	^'Google Sitemap'! !

!Sitemap class methodsFor: 'private' stamp: 'pmm 2/2/2006 10:46'!
logoColors
	^#('wht' 'gry' 'blk')! !

!Sitemap class methodsFor: 'private' stamp: 'pmm 2/2/2006 10:46'!
logoSizes
	^#('30' '40' '50' '60')! !

!Sitemap methodsFor: 'visiting' stamp: 'pmm 2/2/2006 12:21'!
accept: aVisitor
	aVisitor visitSitemap: self! !

!Sitemap methodsFor: 'initialize-release' stamp: 'pmm 2/2/2006 10:56'!
initialize
	super initialize.
	self logoColor: self class logoColors first.
	self logoSize: self class logoSizes last! !

!Sitemap methodsFor: 'accessing' stamp: 'pmm 2/2/2006 10:47'!
logoColor
	^logoColor! !

!Sitemap methodsFor: 'accessing' stamp: 'pmm 2/2/2006 10:47'!
logoColor: aString 
	logoColor := aString! !

!Sitemap methodsFor: 'accessing' stamp: 'pmm 2/2/2006 10:47'!
logoSize
	^logoSize! !

!Sitemap methodsFor: 'accessing' stamp: 'pmm 2/2/2006 10:47'!
logoSize: aString 
	logoSize := aString! !

!Sitemap methodsFor: 'accessing' stamp: 'pmm 2/2/2006 10:48'!
logoUrl
	^String streamContents: [ :stream |
		stream
			nextPutAll: 'https://www.google.com/webmasters/sitemaps/images/logo_';
			nextPutAll: self logoColor;
			nextPut: $_;
			nextPutAll: self logoSize;
			nextPutAll: '.gif' ]! !

!Sitemap methodsFor: 'accessing' stamp: 'pmm 2/2/2006 11:01'!
serverUrl
	^serverUrl! !

!Sitemap methodsFor: 'accessing' stamp: 'pmm 2/2/2006 11:01'!
serverUrl: aString 
	serverUrl := aString! !

!PRVisitor methodsFor: '*Sitemap' stamp: 'pmm 2/2/2006 12:21'!
visitSitemap: aSitemap
	self visitStructure: aSitemap! !

PRVisitor subclass: #SitemapGenerator
	instanceVariableNames: 'serverUrl document root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sitemap-Model'!

!SitemapGenerator commentStamp: '<historical>' prior: 0!
http://www.google.com/schemas/sitemap/0.84/
https://www.google.com/webmasters/sitemaps/docs/en/protocol.html
http://www.xml.com/pub/a/2005/10/26/google-site-maps.html!

!SitemapGenerator class methodsFor: 'instance creation' stamp: 'pmm 12/9/2005 00:14'!
exmaple1
	| sitemap |
	sitemap := self forKernel: 'default' server: 'http://www.pier.com/'.
	! !

!SitemapGenerator class methodsFor: 'instance creation' stamp: 'pmm 2/2/2006 12:08'!
forKernel: aKernelString server: aServerString
	| kernel root context sitemap |
	kernel := PRKernel instances detect: [ :each | each name = aKernelString ].
	root := kernel root.
	context := PRContext kernel: kernel structure: root.
	PRCurrentContext
		use: context
		during: [ sitemap := self forServerUrl: aServerString ].
	^sitemap
	! !

!SitemapGenerator class methodsFor: 'instance creation' stamp: 'pmm 2/2/2006 12:08'!
forServerUrl: aServerString
	| generator |
	generator := self new serverUrl: aServerString; yourself.
	generator generator.
	^generator
	! !

!SitemapGenerator methodsFor: 'private' stamp: 'pmm 1/30/2006 21:39'!
add: aPage
	| url location timestamp lastModification |
	url := XMLElement named: 'url'.
	location := XMLElement named: 'location'.
	location addContent: (XMLStringNode string:
		(String streamContents: [ :stream |
			stream nextPutAll: self serverUrl.
			aPage parents
				do: [ :each | stream nextPutAll: each title ]
				separatedBy: [ stream nextPut: '/' ] ]) ).
	url addElement: location.
	timestamp := aPage modificationTimestamp.
	timestamp isNil ifFalse: [
		lastModification := XMLElement named: 'lastmod'.
		lastModification addContent: (XMLStringNode string: timestamp date yyyymmdd).
		url addElement: lastModification ].
	self root addElement: url! !

!SitemapGenerator methodsFor: 'accessing' stamp: 'pmm 12/8/2005 23:57'!
context
	^PRCurrentContext value! !

!SitemapGenerator methodsFor: 'accessing' stamp: 'pmm 12/8/2005 23:55'!
document
	^document! !

!SitemapGenerator methodsFor: 'accessing' stamp: 'pmm 12/8/2005 23:55'!
document: anXmlDocument 
	document := anXmlDocument! !

!SitemapGenerator methodsFor: 'public' stamp: 'pmm 2/2/2006 12:01'!
generate
	^self visit: PRCurrentContext value root! !

!SitemapGenerator methodsFor: 'testing' stamp: 'pmm 12/8/2005 23:47'!
ignoreChildrenOf: aPage
	^self ignore: aPage! !

!SitemapGenerator methodsFor: 'testing' stamp: 'pmm 12/8/2005 23:43'!
ignore: aPage
	^aPage title = 'Environment'! !

!SitemapGenerator methodsFor: 'initialize-release' stamp: 'pmm 12/9/2005 15:09'!
initialize
	super initialize.
	self document: (XMLDocument new
		version: '1.0';
		encoding: 'UTF-8';
		yourself).
	self root: (XMLElement named: 'urlset').
	self root attributeAt: 'xmlns' put: 'http://www.google.com/schemas/sitemap/0.84'.
	document addElement: root
	! !

!SitemapGenerator methodsFor: 'accessing' stamp: 'pmm 12/8/2005 23:55'!
root
	^root! !

!SitemapGenerator methodsFor: 'accessing' stamp: 'pmm 12/8/2005 23:56'!
root: anXmlElement 
	root := anXmlElement! !

!SitemapGenerator methodsFor: 'accessing' stamp: 'pmm 12/8/2005 23:55'!
serverUrl
	^serverUrl! !

!SitemapGenerator methodsFor: 'accessing' stamp: 'pmm 12/8/2005 23:56'!
serverUrl: aString 
	serverUrl := aString! !

!SitemapGenerator methodsFor: 'visiting-structure' stamp: 'pmm 12/8/2005 23:47'!
visitPage: aPage
	(self ignore: aPage) ifFalse: [
		self add: aPage ].
	(self ignoreChildrenOf: aPage) ifFalse: [
		super visitPage: aPage ]! !

!SitemapGenerator methodsFor: 'accessing' stamp: 'pmm 12/9/2005 00:22'!
xmlString
	^String streamContents: [ :stream |
		self document printCanonicalOn: stream ].! !

!SitemapGenerator methodsFor: 'accessing' stamp: 'pmm 2/2/2006 12:07'!
xmlStringGZipCompressed
	^String streamContents: [ :stream |
		| gzipStream |
		gzipStream := GZipWriteStream on: stream.
		self document printCanonicalOn: gzipStream ].! !
